SystemOrganization addCategory: #TPDBZ!

Object subclass: #Guerrero
	instanceVariableNames: 'nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:23'!
agregarAliado: unGuerrero
self aliados add: unGuerrero! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados
	^ aliados! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados: anObject
	aliados := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:54'!
aliarseCon: unGuerrero
(self puedeAliarseCon: unGuerrero) ifTrue:[ self concretarAlianzaCon: unGuerrero ] ifFalse: [ self error: 'Imposible realizar la alianza pedida' ].! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia
	^ cantidadDeEnergia! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia: anObject
	cantidadDeEnergia := anObject! !

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:36'!
concretarAlianzaCon: unGuerrero 
self agregarAliado: unGuerrero.
unGuerrero agregarAliado: self.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:37'!
esBueno
^tipo esBueno.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:33'!
esDebil 
^(nivelDePelea<15000)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 01:51'!
esMasGrosoQue: unGuerrero
^((self nivelDePelea + self nivelesDePeleaAliados)> unGuerrero nivelDePelea).! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas
	^ esferas! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas: anObject
	esferas := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea
	^ nivelDePelea! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea: anObject
	nivelDePelea := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 01:49'!
nivelesDePeleaAliados
self aliados collect:[ :unAliado | unAliado nivelDePelea] sum.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 16:58'!
puedeAliarseCon: unGuerrero 
^(unGuerrero aceptaA: self) & (self aceptaA: unGuerrero)! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:09'!
puntosDeVida
	^ puntosDeVida! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:10'!
puntosDeVida: anObject
	puntosDeVida := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio
	^ semillasDelHermitanio! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio: anObject
	semillasDelHermitanio := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 17:36'!
tipo
	^ tipo! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 17:36'!
tipo: anObject
	tipo := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje
	^ traje! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje: anObject
	traje := anObject! !

Guerrero subclass: #Monstruo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Monstruo methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 16:57'!
aceptaA: unGuerrero 
^true.! !

!Monstruo methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:29'!
podesHacer: unAtaque 
^ unAtaque puedeRealizarsePorMonstruo: self  ! !

Guerrero subclass: #Saiyajin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Saiyajin methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 17:00'!
aceptaA: unGuerrero
^(unGuerrero esMasGrosoQue: self not)! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:35'!
podesHacer: unAtaque
^unAtaque puedeRealizarsePorSaiyajin: self ! !

Guerrero subclass: #Terricola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:58'!
aceptaA: unGuerrero
^(unGuerrero esBueno & (self meEntra: unGuerrero))! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 18:09'!
aliadosDebiles
^self aliados select: [ :unAliado | unAliado esDebil] ! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:30'!
cantAliadosDebiles
^self aliadosDebiles size! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:30'!
meEntra: unGuerrero
^(unGuerrero esDebil & (self cantAliadosDebiles >5)) not! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:22'!
podesHacer: unPoder 
^unPoder  puedeRealizarsePorTerricola: self ! !

Object subclass: #PoderColectivo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:50'!
puedeRealizarsePorMonstruo: unMonstruo 
^ true! !

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:51'!
puedeRealizarsePorSaiyajin: unSaiyajin
^ true! !

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:52'!
puedeRealizarsePorTerricola: unTerricola 
^true! !

Object subclass: #PoderLiviano
	instanceVariableNames: 'puntosDeAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 18:10'!
puedeRealizarsePorMonstruo: unMonstruo
^ unMonstruo  cantidadDeEnergia  > 50! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 18:10'!
puedeRealizarsePorSaiyajin: unSaiyajin
^ unSaiyajin  cantidadDeEnergia  > 50! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 18:11'!
puedeRealizarsePorTerricola: unTerricola 
^unTerricola cantidadDeEnergia  > 50! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque
	^ puntosDeAtaque! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque: anObject
	puntosDeAtaque := anObject! !

Object subclass: #PoderPotente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:47'!
puedeRealizarsePorMonstruo: unMonstruo 
^ true! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:47'!
puedeRealizarsePorSaiyajin: unSaiyajin
^ true! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 18:21'!
puedeRealizarsePorTerricola: unTerricola 
^((unTerricola cantidadDeEnergia ) * 0.25) < 500! !

Object subclass: #PoderVengativo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

Object subclass: #TipoBueno
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoBueno methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^true! !

Object subclass: #TipoMalo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoMalo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^false! !

Object subclass: #Traje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Traje methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/14/2013 22:43'!
portador: unGuerrero suTrajeResiste: unAtaque
	^(unAtaque * 0,90).! !

Traje subclass: #TrajeEntrenamiento
	instanceVariableNames: 'ataquesRecibidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TrajeEntrenamiento methodsFor: 'accessing' stamp: 'LoguancioMartin 10/14/2013 22:46'!
ataquesRecibidos
	^ ataquesRecibidos! !

!TrajeEntrenamiento methodsFor: 'accessing' stamp: 'LoguancioMartin 10/14/2013 22:46'!
ataquesRecibidos: anObject
	ataquesRecibidos := anObject! !

!TrajeEntrenamiento methodsFor: 'accessing' stamp: 'LoguancioMartin 10/14/2013 22:55'!
portador: unGuerrero suTrajeResiste: unAtaque
	ataquesRecibidos := ataquesRecibidos +1.
	unGuerrero cantidadDeEnergia: ((unGuerrero cantidadDeEnergia) -20).
	(ataquesRecibidos =3) ifTrue: [ self ataquesRecibidos: 0.
									unGuerrero nivelDePelea: ((unGuerrero nivelDePelea) + 100) .] .
	^(unAtaque * 0,90).! !

Traje subclass: #TrajeEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TrajeEspecial methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/14/2013 22:42'!
portador: unGuerrero suTrajeResiste: unAtaque
	^(unAtaque * 0,90)-20.! !
